diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index d663aa894..b1a0c2994 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1,12 +1,9 @@
 package net.minecraft.datagen;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryDyeing;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+import net.minecraft.core.data.registry.recipe.entry.*;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilderShaped;
 import net.minecraft.core.block.Blocks;
@@ -150,12 +147,12 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
-                "#S#",
-                "#N#",
-                "#R#")
+                "###",
+                "CSR",
+                "###")
             .addInput('#', Blocks.COBBLE_NETHERRACK)
             .addInput('S', Blocks.SOULSAND)
-            .addInput('N', Items.RUBYGLASS_CRYSTAL)
+            .addInput('C', Blocks.RUBYGLASS_CONDUIT)
             .addInput('R', Items.DUST_REDSTONE)
             .create("activator", Blocks.ACTIVATOR_COBBLE_NETHERRACK.getDefaultStack());
 
@@ -373,12 +370,12 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.SPONGE_DRY)
-            .addInput(Items.BUCKET_WATER)
+            .addInput("minecraft:water_buckets")
             .create("sponge_to_wet_sponge", Blocks.SPONGE_WET.getDefaultStack());
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.PUMICE_DRY)
-            .addInput(Items.BUCKET_LAVA)
+            .addInput("minecraft:lava_buckets")
             .create("pumice_to_wet_pumice", Blocks.PUMICE_WET.getDefaultStack());
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
@@ -529,7 +526,15 @@ class WorkbenchGenerator {
                 "# #",
                 " # ")
             .addInput('#', Items.INGOT_IRON)
-            .create("bucket", Items.BUCKET.getDefaultStack());
+            .create("iron_bucket", Items.BUCKET_IRON.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                    "# #",
+                    "*#*")
+            .addInput('#', Items.INGOT_STEEL)
+            .addInput('*', Items.INGOT_STEEL_CRUDE)
+            .create("steel_bucket", Items.BUCKET_STEEL.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1060,33 +1065,32 @@ class WorkbenchGenerator {
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
             .create("cookie", new ItemStack(Items.FOOD_COOKIE, 16));
 
-        RecipeBuilderShaped cake = RecipeBuilder.Shaped(CORE_NAMESPACE)
+        RecipeBuilderShaped cakeBase = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "AAA",
                 "BEB",
                 "CCC")
-            .setConsumeContainer(false);
-
-        cake.addInput('A', Items.BUCKET_MILK)
+            .setConsumeContainer(false)
+            .addInput('A', "minecraft:milk_buckets")
             .addInput('B', Items.DUST_SUGAR)
-            .addInput('E', Items.EGG_CHICKEN)
-            .addInput('C', Items.DOUGH)
-            .create("cake", Items.FOOD_CAKE.getDefaultStack());
+            .addInput('C', Items.DOUGH);
 
-        cake.addInput('A', Items.BUCKET_MILK)
-            .addInput('B', Items.DUST_SUGAR)
-            .addInput('E', Blocks.PUMPKIN)
-            .addInput('C', Items.DOUGH)
-            .create("pumpkin_pie", Items.FOOD_PUMPKIN_PIE.getDefaultStack());
+        cakeBase.addInput('E', Items.EGG_CHICKEN).create("cake", Items.FOOD_CAKE.getDefaultStack());
+        cakeBase.addInput('E', Blocks.PUMPKIN).create("pumpkin_pie", Items.FOOD_PUMPKIN_PIE.getDefaultStack());
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "X#X",
-                "XXX")
-            .addInput('X', Blocks.BLOCK_GOLD)
-            .addInput('#', Items.FOOD_APPLE)
-            .create("golden_apple", Items.FOOD_APPLE_GOLD.getDefaultStack());
+        generateIceCreamProgression(Items.BUCKET_IRON, "iron");
+        generateIceCreamProgression(Items.BUCKET_STEEL, "steel");
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.SUGARCANE).create("sugar_cane_to_sugar", new ItemStack(Items.DUST_SUGAR, 3));
+    }
+
+    /**
+     * Dynamically generates the Ice Cream crafting progression for any given bucket type.
+     * @param bucketItem The Item instance of the bucket (Items.BUCKET_STEEL, Items.BUCKET_IRON, etc.)
+     * @param materialName The string name for the recipe ID ("steel", "iron", etc.)
+     */
+    public static void generateIceCreamProgression(Item bucketItem, String materialName) {
+        int max = ((ItemBucket) bucketItem).maxCharges;
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1096,11 +1100,23 @@ class WorkbenchGenerator {
             .addInput('Y', Items.FOOD_CHERRY)
             .addInput('O', new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
             .addInput('#', Items.AMMO_SNOWBALL)
-            .addInput('X', Items.BUCKET_MILK)
+            .addInput('X', ItemBucket.createRecipeInput(bucketItem, ItemBucket.STATE_MILK))
             .setConsumeContainer(true)
-            .create("ice_cream_bucket", Items.BUCKET_ICECREAM.getDefaultStack());
+            .create("icecream_bucket_" + materialName + "_from_milk", ItemBucket.createItemStack(bucketItem, ItemBucket.STATE_ICECREAM, 1));
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.SUGARCANE).create("sugar_cane_to_sugar", new ItemStack(Items.DUST_SUGAR, 3));
+        for (int currentCharge = 1; currentCharge < max; currentCharge++) {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    " Y ",
+                    "#O#",
+                    " X ")
+                .addInput('Y', Items.FOOD_CHERRY)
+                .addInput('O', new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
+                .addInput('#', Items.AMMO_SNOWBALL)
+                .addInput('X', ItemBucket.createItemStack(bucketItem, ItemBucket.STATE_ICECREAM, currentCharge))
+                .setConsumeContainer(true)
+                .create("icecream_bucket_" + materialName + "_upgrade_" + currentCharge + "_to_" + (currentCharge + 1), ItemBucket.createItemStack(bucketItem, ItemBucket.STATE_ICECREAM, currentCharge + 1));
+        }
     }
 
     private static void generateDyes() {
@@ -1329,31 +1345,32 @@ class WorkbenchGenerator {
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "#Q#",
-                "#S#",
-                "#R#"
+                "#C#",
+                "#Q#"
             )
             .addInput('#', Blocks.COBBLE_NETHERRACK)
             .addInput('Q', Items.QUARTZ)
-            .addInput('R', Items.RUBYGLASS_CRYSTAL)
-            .addInput('S', Blocks.SOULSAND)
+            .addInput('C', Blocks.RUBYGLASS_CONDUIT)
             .create("matcher", new ItemStack(Blocks.MATCHER, 1));
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
                 .setShape(
                         "XOX",
-                        "OOO",
+                        "ORO",
                         "XOX")
+                .addInput('R', Items.DUST_REDSTONE)
                 .addInput('O', Items.RUBYGLASS_CRYSTAL)
                 .addInput('X', Blocks.COBBLE_NETHERRACK)
-                .create("rubyglass_circuit", new ItemStack(Blocks.RUBYGLASS_CIRCUIT, 1));
+                .create("rubyglass_conduit", new ItemStack(Blocks.RUBYGLASS_CONDUIT, 1));
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
                 .setShape(
                         "###",
-                        "#RB",
+                        "CQB",
                         "###")
-                .addInput('#', Blocks.COBBLE_NETHERRACK)
-                .addInput('R', Items.RUBYGLASS_CRYSTAL)
+                .addInput('#', Blocks.COBBLE_STONE_MOSSY)
+                .addInput('C', Blocks.RUBYGLASS_CONDUIT)
+                .addInput('Q', Items.QUARTZ)
                 .addInput('B', Items.BONE)
                 .create("motion_sensor", Blocks.MOTION_SENSOR_IDLE.getDefaultStack());
     }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
index 9765b4c1b..1bafdf30a 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
@@ -20,17 +20,18 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
     protected int height;
     protected boolean consumeContainer = DEFAULT_CONSUME_CONTAINER;
     protected boolean allowMirrored = DEFAULT_ALLOW_MIRROR;
-    protected final HashMap<Character, RecipeSymbol> symbolShapedMap = new HashMap<>();
+    protected HashMap<Character, RecipeSymbol> symbolShapedMap = new HashMap<>();
+
     /**
-     * Used for creating new shaped workbench recipes.
-     * @param modID Namespace to create recipe under
+     * Used for creating new-shaped workbench recipes.
+     * @param modID Namespace to create a recipe under
      */
     public RecipeBuilderShaped(String modID){
         super(modID);
     }
     /**
-     * Used for creating new shaped workbench recipes.
-     * @param modID Namespace to create recipe under
+     * Used for creating new-shaped workbench recipes.
+     * @param modID Namespace to create a recipe under
      * @param shape Recipe shape in symbol representation
      */
     public RecipeBuilderShaped(String modID, String... shape) {
@@ -101,22 +102,21 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
     /**
      * Specifies whether the recipe should consume container items.
      * <pre>{@code
-     *     RecipeBuilderShaped("minecraft")
-     *       .setShape(
-     *          "BBB",
-     *          "SES",
-     *          "WWW")
-     *       .addInput('B', Item.bucketMilk)
-     *       .addInput('S', Item.dustSugar)
-     *       .addInput('E', Item.eggChicken)
-     *       .addInput('W', Item.wheat)
-     *       .setConsumeContainer(false) // Recipe will return empty buckets when crafted
-     *       .create("cake", Item.cake.getDefaultStack());
+     * RecipeBuilder.Shaped("minecraft")
+     *      .setShape(
+     *          "AAA",
+     *          "BEB",
+     *          "CCC")
+     *      .addInput('A', "minecraft:milk_buckets")
+     *      .addInput('B', Items.DUST_SUGAR)
+     *      .addInput('E', Items.EGG_CHICKEN)
+     *      .addInput('C', Items.DOUGH)
+     *      .setConsumeContainer(false) // Recipe will leave empty or decremented buckets behind
+     *      .create("cake", Items.FOOD_CAKE.getDefaultStack());
      * }</pre>
      * @param consumeContainer Should consume ContainerItem
      * @return Copy of {@link RecipeBuilderShaped}
      */
-    @SuppressWarnings({"unused"})
     public RecipeBuilderShaped setConsumeContainer(boolean consumeContainer){
         RecipeBuilderShaped builder = this.clone(this);
         builder.consumeContainer = consumeContainer;
@@ -129,6 +129,13 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
         return builder;
     }
 
+    @Override
+    public RecipeBuilderShaped clone() {
+        RecipeBuilderShaped cloned = (RecipeBuilderShaped) super.clone();
+        cloned.symbolShapedMap = new HashMap<>(this.symbolShapedMap);
+        return cloned;
+    }
+
     /**
      * Assigns an item to an item symbol defined in the shape (see {@link #setShape(String...)})
      * @param templateSymbol Item symbol character
@@ -184,8 +191,8 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
     @SuppressWarnings({"unused"})
     public RecipeBuilderShaped addInput(char templateSymbol, RecipeSymbol symbol){
         if (templateSymbol == ' ') throw new IllegalArgumentException("Cannot assign item to protected symbol ' ' pick a different symbol for your recipe input");
-        RecipeBuilderShaped builder = this.clone(this);
-        symbolShapedMap.put(templateSymbol, symbol);
+        RecipeBuilderShaped builder = this.clone();
+        builder.symbolShapedMap.put(templateSymbol, symbol);
         return builder;
     }
 
@@ -199,15 +206,15 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
                 if (shape[y].length() > x) {
                     cha = shape[y].charAt(x);
                 }
-                RecipeSymbol tempplate = symbolShapedMap.get(cha);
-                if (tempplate == null){
+                RecipeSymbol template = symbolShapedMap.get(cha);
+                if (template == null){
                     recipe[x + y * width] = null;
                 } else {
-                    if(tempplate.getItemGroup() == null){
-                        RecipeSymbol s =  new RecipeSymbol(cha == null ? ' ' : cha, tempplate.getStack());
+                    if(template.getItemGroup() == null){
+                        RecipeSymbol s =  new RecipeSymbol(cha == null ? ' ' : cha, template.getStack());
                         recipe[x + y * width] = s;
                     } else {
-                        recipe[x + y * width] = new RecipeSymbol(cha == null ? ' ' : cha, tempplate.getStack(), tempplate.getItemGroup());
+                        recipe[x + y * width] = new RecipeSymbol(cha == null ? ' ' : cha, template.getStack(), template.getItemGroup());
                     }
 
                 }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
index c9c644c2f..f73b51f76 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
@@ -12,15 +12,24 @@ import java.util.ArrayList;
 import java.util.List;
 
 public class RecipeBuilderShapeless extends RecipeBuilderBase{
-    private final List<RecipeSymbol> symbolShapelessList = new ArrayList<>();
+
+    private List<RecipeSymbol> symbolShapelessList = new ArrayList<>();
+
     /**
      * Used for creating new shapeless workbench recipes.
-     * @param modID Namespace to create recipe under
+     * @param modID Namespace to create a recipe under
      */
     public RecipeBuilderShapeless(String modID) {
         super(modID);
     }
 
+    @Override
+    public RecipeBuilderShapeless clone() {
+        RecipeBuilderShapeless cloned = (RecipeBuilderShapeless) super.clone();
+        cloned.symbolShapelessList = new ArrayList<>(this.symbolShapelessList);
+        return cloned;
+    }
+
     /**
      * @param stack Item to add to recipe's item list
      * @return Copy of {@link RecipeBuilderShapeless}
@@ -66,10 +75,11 @@ public class RecipeBuilderShapeless extends RecipeBuilderBase{
      */
     @SuppressWarnings({"unused"})
     public RecipeBuilderShapeless addInput(RecipeSymbol symbol){
-        RecipeBuilderShapeless builder = this.clone(this);
-        symbolShapelessList.add(symbol);
+        RecipeBuilderShapeless builder = this.clone();
+        builder.symbolShapelessList.add(symbol);
         return builder;
     }
+
     @Override
     @SuppressWarnings({"unused", "unchecked"})
     public void create(String recipeID, ItemStack outputStack) {
